module Main where

import Graphics.UI.GLUT
import Data.IORef
import Bindings
import Engine
import Parse

timeStep :: Int 
timeStep = 1000


main :: IO ()
main = do
  (_progName, args) <- getArgsAndInitialize
  initialDisplayMode $= [DoubleBuffered]
  _window <- createWindow "Conway's game of life"

  k <- if not $ null args then parse args else pure []

  cells <- newIORef $ startingmem k
  pos <- newIORef (0, 0)
  time <- newIORef timeStep
  stop <- newIORef True
  zoom <- newIORef 1

  reshapeCallback $= Just reshape
  keyboardMouseCallback $= Just (keyboardMouse cells zoom pos time stop)
  idleCallback $= Nothing
  displayCallback $= display zoom cells pos
  addTimerCallback timeStep (looper cells time stop )
  mainLoop