module Cells (Cells, updatem, rendercells) where

import Graphics.UI.GLUT
import Engine

vertex3f :: (GLfloat, GLfloat, GLfloat) -> IO ()
vertex3f (x, y, z) = vertex $ Vertex3 x y z

--cell :: GLfloat  -> IO ()
cell :: (Integral b, Integral a) => GLfloat -> (a, b) -> IO ()
cell w (x, y) = renderPrimitive Quads $ mapM_ vertex3f
  [ ( x' +w, y' +w, 0), 
    ( x' +w, y' -w, 0),  
    ( x' -w, y' -w, 0), 
    ( x' -w, y' +w, 0)]
  where x' = fromIntegral x/10
        y' = fromIntegral y/10

rendercells :: Cells -> IO ()
rendercells cells = mapM_ (cell 0.05) (pointlist cells)