{-# LANGUAGE BlockArguments #-}

module Display where

import Cells
import Control.Monad
import Data.IORef
import Graphics.UI.GLUT

display ::
  IORef GLfloat ->
  IORef Cells ->
  IORef (GLfloat, GLfloat) ->
  DisplayCallback
display z cells pos = do
  clear [ColorBuffer]
  (x', y') <- get pos
  old <- get cells
  zoom <- get z
  size <- get windowSize

  viewport $= (Position 0 0, size)
  let Size w' h' = size
  let w = fromIntegral w'
  let h = fromIntegral h'

  matrixMode $= Projection
  loadIdentity
  let ar = w / h
  ortho2D (-1 * ar) (1 * ar) (-1) 1
  matrixMode $= Modelview 0
  loadIdentity
  clear [ColorBuffer]

  translate $ Vector3 x' y' 0
  scale zoom zoom zoom

  color $ Color3 1 1 (1 :: Float)
  rendercells old
  swapBuffers
