{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE TupleSections #-}
module Parse where

import qualified Data.Text as T
import qualified Data.Text.IO as T

parse args = do 
    c <- T.readFile (head args)
    let [content, filename] = T.split (== '.') . T.pack . head $ args
    case filename of
        "cells" -> pure $ fmap flipxy . concat . tocoords . zip [0..] . fmap findOs . filtercommentsc . T.lines $ c
        "rle" -> pure $ []

flipxy :: (b, a) -> (a, b)
flipxy (x, y) = (y, x)

-- .cells file parsing
filtercommentsc :: [T.Text] -> [T.Text]
filtercommentsc = filter (not . T.isPrefixOf "!")

findOs :: T.Text -> [Integer]
findOs = fmap fst . filter (\(_, y) -> y == 'O' ) . zip [0..] . T.unpack

tocoords :: [(a, [b])] -> [[(a, b)]]
tocoords = fmap (\(x, xs) -> fmap (x,) xs)

-- .rle file parsing